package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ListPortsLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewListPortsLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ListPortsLogic {
	return &ListPortsLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ListPortsLogic) ListPorts(req *types.ListPortsReq) (resp *types.ListPortsResp, err error) {
	// todo: add your logic here and delete this line
	ListPortsReq := &openstack.ListPortsReq{}
	err = copier.CopyWithOption(ListPortsReq, req, copier.Option{Converters: utils.Converters})
	ListPortsResp, err := l.svcCtx.OpenstackRpc.ListPorts(l.ctx, ListPortsReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ListPortsResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ListPortsResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
